/* choice -- match incoming list against a collection of stored templates. */

/*  Copyright 1999 Miller Puckette.
Permission is granted to use this software for any purpose provided you
keep this copyright notice intact.

THE AUTHOR AND HIS EMPLOYERS MAKE NO WARRANTY, EXPRESS OR IMPLIED,
IN CONNECTION WITH THIS SOFTWARE.
 
This file is downloadable from http://www.crca.ucsd.edu/~msp .
*/

#include "m_imp.h"
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <fcntl.h>
#include </usr/src/linux/include/linux/joystick.h>

typedef struct joystick
{
    t_object x_ob;
    int x_fd;
} t_joystick;

void joystick_poll(t_joystick *x)
{
    struct js_event e;
    if (x->x_fd >= 0)
    {
    	int r = read (x->x_fd, &e, sizeof(e));
	if (r == sizeof(e))
	{
	    t_atom at[4];
	    SETFLOAT(at, e.type);
	    SETFLOAT(at + 1, e.number);
	    SETFLOAT(at + 2, e.value);
	    SETFLOAT(at + 3, e.time);
	    outlet_list(x->x_ob.ob_outlet, 0, 4, at);
    	}
    	else post("joystick read returned %d", r);
    }
}

void joystick_float(t_joystick *x, t_floatarg f)
{
    if (f != 0)
    {
	if (x->x_fd >= 0)
    	    return;
	x->x_fd = open ("/dev/js0", O_RDONLY);
	if (x->x_fd < 0)
	{
	    post("/dev/js0: %s", strerror(errno));
    	    pd_error(x, "couldn't open joystick\n");
	    return;
	}
	sys_addpollfn(x->x_fd, (t_fdpollfn)joystick_poll, x);
    }
    else
    {
    	if (x->x_fd >= 0)
	{
    	    sys_rmpollfn(x->x_fd);
    	    close(x->x_fd);
	    x->x_fd = -1;
    	}
    }
}

void joystick_free(t_joystick *x)
{
    joystick_float(x, 0);
}

t_class *joystick_class;

t_joystick *joystick_new(void)
{
    t_joystick *x = (t_joystick *)pd_new(joystick_class);
    outlet_new(&x->x_ob, &s_list);
    x->x_fd = -1;
    return (x);
}

void joystick_setup(void)
{
    post("joystick v0.1");
    joystick_class = class_new(gensym("joystick"), (t_newmethod)joystick_new,
    	(t_method)joystick_free, sizeof(t_joystick), 0, 0);
    class_addfloat(joystick_class, joystick_float);
}

